-- TODO
-- 1h/2h handling
-- ring/trinket handling
-- refresh data
-- register for equip change events
-- second list for all inventory
-- tab or section of character panel...don't think this is going to work, maybe overlay with hook instead?

local _G = _G
local pairs = pairs
local sfind = string.find
local tconcat = table.concat
local tinsert = table.insert
local tsort = table.sort
local tremove = table.remove

-- Frames
local ScgsFrame
-- ScgsFrame = {}
local btnClose
local btnReloadUi
local btnRefresh
local fsSlot = {}
local fsIlvl = {}
local fsName = {}
local fsRegion = {}

-- Other
local itemtable = {}
local slots = {["Back"] = "BackSlot", ["Chest"] = "ChestSlot", ["Feet"] = "FeetSlot", ["Finger 1"] = "Finger0Slot", ["Finger 2"] = "Finger1Slot", ["Hands"] = "HandsSlot", ["Head"] = "HeadSlot", ["Legs"] = "LegsSlot", ["Main Hand"] = "MainHandSlot", ["Neck"] = "NeckSlot", ["Off Hand"] = "SecondaryHandSlot", ["Shoulders"] = "ShoulderSlot", ["Trinket 1"] = "Trinket0Slot", ["Trinket 2"] = "Trinket1Slot", ["Waist"] = "WaistSlot", ["Wrist"] = "WristSlot"}
local backdropTable = { bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } }
BINDING_HEADER_GEAR_SUMMARY = "Gear Summary"
BINDING_NAME_GEAR_SUMMARY_TOGGLE = "Toggle Gear Summary Window"
BINDING_NAME_GEAR_SUMMARY_REFRESH = "Refresh Gear Summary Data"
SLASH_SCGEARSUMMARY1 = "/scg"

local function GetSlotStuffOld(slotName)
	local itemid = GetInventoryItemID("player",GetInventorySlotInfo(slots[slotName]))
	local t = {}
	if itemid ~= nil then
		t.slot = slots[slotName]
		t.slotName = slotName
		t.name,t.link,t.quality,t.ilvl,t.reqLevel,t.class,t.subclass,t.maxStack,t.equipSlot,t.texture,t.vendorPrice = GetItemInfo(itemid)
	else
		t = nil
	end
	return t
end

local function GetSlotStuff(slotName)
	local itemlink = GetInventoryItemLink("player",GetInventorySlotInfo(slots[slotName]))
	local t = {}
	if itemlink ~= nil then
		t.slot = slots[slotName]
		t.slotName = slotName
		t.name,t.link,t.quality,t.ilvl,t.reqLevel,t.class,t.subclass,t.maxStack,t.equipSlot,t.texture,t.vendorPrice = GetItemInfo(itemlink)
	else
		t = nil
	end
	return t
end

local function ReadItems()
	local i = 0
	for k, v in pairs(slots) do
		i = i + 1
		itemtable[i] = GetSlotStuff(k)
	end
	tsort(itemtable,
		function (a,b)
			if a == nil then
				return false
			elseif b == nil then
				return true
			elseif a.ilvl < b.ilvl then
				return true
			else
				return false
			end
		end
	)
end

local function RefreshData()
	-- TODO: update the displayed data
	itemtable = wipe(itemtable)
	ReadItems()
	local i = 0
	for k, v in pairs(itemtable) do
		i = i + 1
		if v ~= nil then
			fsSlot[i]:SetText(v.slotName)
			fsIlvl[i]:SetText(v.ilvl)
			fsName[i]:SetText(v.link)
		else
			fsSlot[i]:SetText("")
			fsIlvl[i]:SetText("")
			fsName[i]:SetText("")
		end
	end
end

local function OnEvent(self, event, ...)
	if event == "UNIT_INVENTORY_CHANGED" then
		if ScgsFrame:IsShown() then
			RefreshData()
		end
	end
end

local function InitFrames()
	ScgsFrame = CreateFrame("Frame", "ScgsFrame", UIParent)
	tinsert(UISpecialFrames, "ScgsFrame")
	ScgsFrame:SetWidth(600)
	ScgsFrame:SetHeight(375)
	ScgsFrame:SetPoint("CENTER", UIParent, "CENTER")
	ScgsFrame:SetFrameStrata("DIALOG")
	ScgsFrame:SetBackdrop(backdropTable)
	ScgsFrame:SetBackdropColor(0, 0, 0, 1)
	ScgsFrame:SetMovable(true)
	ScgsFrame:SetClampedToScreen(true)
	ScgsFrame:EnableMouse(true)
	ScgsFrame:RegisterForDrag("LeftButton")
	ScgsFrame:SetScript("OnDragStart", function() ScgsFrame:StartMoving() end)
	ScgsFrame:SetScript("OnDragStop", function() ScgsFrame:StopMovingOrSizing() end)
	ScgsFrame:SetScript("OnEvent", OnEvent)
	ScgsFrame:RegisterEvent("UNIT_INVENTORY_CHANGED")

	btnClose = CreateFrame("Button", nil, ScgsFrame, "UIPanelCloseButton")
	btnClose:SetPoint("TOPRIGHT", ScgsFrame, "TOPRIGHT")
	
	btnReloadUi = CreateFrame("Button", "btnReloadUi", ScgsFrame,"UIPanelButtonTemplate")
	btnReloadUi:SetText("RUI")
	btnReloadUi:SetPoint("TOPRIGHT",btnClose,"TOPLEFT",0,-5)
	btnReloadUi:Show()
	btnReloadUi:SetScript("OnClick", function() ReloadUI(); end)
	
	btnRefresh = CreateFrame("Button", "btnRefresh", ScgsFrame,"UIPanelButtonTemplate")
	btnRefresh:SetText("Refresh")
	btnRefresh:SetSize(60,20)
	btnRefresh:SetPoint("TOPRIGHT",btnReloadUi,"TOPLEFT",0,-1)
	btnRefresh:Show()
	btnRefresh:SetScript("OnClick", function() RefreshData(); end)
			
	local i = 0
	local maxWidth = 0
	for k, v in pairs(itemtable) do
		i = i + 1
		fsSlot[i] = ScgsFrame:CreateFontString(nil, "OVERLAY")
		fsSlot[i]:SetTextColor(1, 1, 1, 1)
		fsSlot[i]:SetPoint("TOPLEFT", ScgsFrame, "TOPLEFT", 12, (-i*20)-10)
		fsSlot[i]:SetFont("Fonts\\ARIALN.TTF", 14, "")
		fsSlot[i]:SetText(v.slotName)
		fsIlvl[i] = ScgsFrame:CreateFontString(nil, "OVERLAY")
		fsIlvl[i]:SetTextColor(1, 1, 1, 1)
		fsIlvl[i]:SetPoint("TOPLEFT", ScgsFrame, "TOPLEFT", 100, (-i*20)-10)
		fsIlvl[i]:SetFont("Fonts\\ARIALN.TTF", 14, "")
		fsIlvl[i]:SetText(v.ilvl)

		local tmpFontString = ScgsFrame:CreateFontString(nil, "OVERLAY")
		tmpFontString:SetWidth(600)
		tmpFontString:SetHeight(20)
		tmpFontString:SetFont("Fonts\\ARIALN.TTF", 14, "")
		tmpFontString:SetJustifyH("LEFT")
		tmpFontString:SetText(v.link)
		local thisWidth = tmpFontString:GetStringWidth()
		if thisWidth > maxWidth then
			maxWidth = thisWidth
		end			
		
		fsName[i] = CreateFrame("SimpleHTML","fsName"..i,ScgsFrame)
		fsName[i]:SetWidth(400)
		fsName[i]:SetHeight(1)
		fsName[i]:SetPoint("TOPLEFT", ScgsFrame, "TOPLEFT", 150, (-i*20)-10)
		fsName[i]:SetFont("Fonts\\ARIALN.TTF", 14, "")
		fsName[i]:SetText(v.link)
		fsName[i]:SetScript("OnHyperlinkEnter", function() GameTooltip:SetOwner(fsName[i], "ANCHOR_CURSOR"); GameTooltip:SetHyperlink(v.link); end)
		fsName[i]:SetScript("OnHyperlinkLeave", function() GameTooltip:Hide(); end)
	end
	ScgsFrame:SetWidth(maxWidth + 165)
end

local function SlashHandler(msg, editbox)
	if not ScgsFrame then		
		ReadItems()
		InitFrames()
	end
	ScgsFrame:Show()
end
SlashCmdList["SCGEARSUMMARY"] = SlashHandler;

local function DebugStuff()

end

function GsToggle()
	if not ScgsFrame then		
		ReadItems()
		InitFrames()
		ScgsFrame:Show()
	elseif ScgsFrame:IsShown() then
		ScgsFrame:Hide()
	else
		ScgsFrame:Show()
		RefreshData()
	end
	DebugStuff()
end

function GsRefresh()

end
